;rob hubbard
;monty on the run music driver
;modified to allow 7F note length
;without append/release effect
;but with a gate=0 effect
;
; performs Driller of Matt Gray using his notes but
; Hubbard's instruments

.ifdef sid
 .byte "PSID"
 .word $0200         ; version 2
 .word $7C00         ; data offset
 .word $0000         ; load address in cbm format
 .byte >initmusic
 .byte <initmusic
 .byte >playmusic
 .byte <playmusic
 .word $0100         ; 1 song
 .word $0100         ; default song
 .word $FFFF
 .word $FFFF
 .byte "Driller Hub Style",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .byte "Stefano Tognon",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .byte "2001 Stefano Tognon",0,0,0,0,0,0,0,0,0,0,0,0,0
 .word $0000
 .word $0000
 .word $0000

.endif

 ;=================================
 ; PRG start address
 ;=================================
 .byte $01,$08

 ;=================================
 ; BASIC startup program
 ;=================================
 .byte $0b,$08,$e8,$03,$9e,"2061",0,0,0

.org 2061
 jsr initmusic

 sei
 lda #<interr
 sta $0314
 lda #>interr
 sta $0315

 lda #$00
 sta $dd0d
 cli

aaa:
 jmp aaa

interr =*

 jsr playmusic
 LDA  $DC0D       ; Registro controllo interruzioni CIA #1
 jmp $ea31


;====================================
;init music

initmusic =*

  lda #$00         ;music num
  ldy #$00
  asl
  sta tempstore
  asl
  clc
  adc tempstore    ;now music num*6
  tax

a1:
  lda songs,x      ;copy ptrs to this
  sta currtrkhi,y  ;music's tracks to
  inx              ;current tracks
  iny
  cpy #$06
  bne a1

  lda #$00         ;clear control regs
  sta $d404
  sta $d40b
  sta $d412
  sta $d417

  lda #$0f         ;full volume
  sta $d418

  lda #$40         ;flag init music
  sta mstatus

  rts


;====================================
;music off

musicoff =*

  lda #$c0         ;flag music off
  sta mstatus
  rts


;====================================
;play music

playmusic =*

  inc counter

  bit mstatus      ;test music status
  bmi moff         ;$80 and $c0 is off
  bvc contplay     ;$40 init, else play


;==========
;init the song (mstatus $40)

  lda #$00         ;init counter
  sta counter

  ldx #3-1
a2:
  sta posoffset,x  ;init pos offsets
  sta patoffset,x  ;init pat offsets
  sta lengthleft,x ;get note right away
  sta notenum,x
  dex
  bpl a2

  sta mstatus      ;signal music play
  jmp contplay


;==========
;music is off (mstatus $80 or $c0)

moff =*

  bvc a3           ;if mstatus $c0 then
  lda #$00
  sta $d404        ;kill voice 1,2,3
  sta $d40b        ;control registers
  sta $d412

  lda #$0f         ;full volume still
  sta $d418

  lda #$80         ;flag no need to kill
  sta mstatus      ;sound next time

a3:
  jmp musicend     ;end


;==========
;music is playing (mstatus otherwise)

contplay =*

  ldx #3-1         ;number of chanels

  dec speed        ;check the speed
  bpl mainloop

  lda resetspd     ;reset speed if needed
  sta speed


mainloop =*

  lda regoffsets,x ;save offset to regs
  sta tmpregofst   ;for this channel
  tay


;check whether a new note is needed

  lda speed        ;if speed not reset
  cmp resetspd     ;then skip notework
  beq checknewnote
  jmp vibrato

checknewnote =*

  lda currtrkhi,x  ;put base addr.w of
  sta $02          ;this track in $2
  lda currtrklo,x
  sta $03

  dec lengthleft,x ;check whether a new
  bmi getnewnote   ;note is needed

  bne goS

  lda savegate,x   ;*
  cmp #$84         ;*
  bne skipgate2    ;*

  txa              ;*
  pha              ;*
  lda instrnr,x    ;* instr num
  asl              ;* instr num*8
  asl              ;*
  asl              ;*
  tax              ;*
  lda instr+2,x    ;*
  and $FE          ;*
  sta $d404,y      ;* release the gate but for a tick only
  pla              ;*
  tax              ;*

skipgate2:         ;*
  lda #$00         ;*
  sta savegate,x   ;*

goS:
  jmp soundwork    ;no new note needed


;==========
;notework
;a new note is needed. get the pattern
;number/cc from this position

getnewnote =*

  ldy posoffset,x  ;get the data from
  lda ($02),y      ;the current position

  cmp #$ff         ;pos $ff restarts
  beq restart

  cmp #$fe         ;pos $fe stops music
  bne getnotedata  ;on all channels

  jsr musicoff     ;**

  jmp musicend

;cc of $ff restarts this track from the
;first position

restart =*

  lda #$00         ;get note immediately
  sta lengthleft,x ;and reset pat,pos
  sta posoffset,x
  sta patoffset,x
  sta savegate,x   ;*
  jmp getnewnote


;get the note data from this pattern

getnotedata =*

  tay
  lda patptl,y     ;put base addr.w of
  sta $04          ;the pattern in $4
  lda patpth,y
  sta $05

  lda #$00         ;default no portamento
  sta portaval,x


  lda savegate,x   ;*
  cmp #$82         ;*
  bne skipgate     ;*

  txa              ;*
  pha              ;*
  lda instrnr,x    ;* instr num
  asl              ;* instr num*8
  asl              ;*
  asl              ;*
  tax              ;*
  lda instr+2,x    ;*
  and $FE          ;*
  sta $d404,y      ;* release the gate but for a short time
  pla              ;*
  tax              ;*

skipgate:          ;*
  lda #$00         ;*
  sta savegate,x   ;*

  ldy patoffset,x  ;get offset into ptn

  lda #$ff         ;default no append
  sta appendfl

;1st byte is the length of the note 0-7f
;//bit5 signals no release (see sndwork)
;//bit6 signals appended note
;bit7 signals a new instrument
;     or portamento coming up

  lda ($04),y      ;get length of note

  cmp #$82         ;* gate at end needed
  bne continue     ;*

gate:              ;*
  sta  savegate,x  ;*
  iny              ;*
  lda ($04),y      ;*
  inc patoffset,x  ;*
continue:          ;*
  cmp  #$84        ;* gate before end needed
  beq  gate        ;*

  sta savelnthcc,x
  sta templnthcc
  and #$7f         ;*
  sta lengthleft,x

  ;bit templnthcc   ;test for append
  ;bvs appendnote

  inc patoffset,x  ;pt to next data

  lda templnthcc   ;2nd byte needed?
  bpl getpitch

;2nd byte needed as 1st byte negative
;2nd byte is the instrument number(+ve)
;or portamento speed(-ve)

  iny
  lda ($04),y      ;get instr/portamento
  bpl a4

  sta portaval,x   ;save portamento val
  jmp a5

a4:
  sta instrnr,x    ;save instr nr

a5: inc patoffset,x

;3rd byte is the pitch of the note
;get the 'base frequency' here

getpitch =*

  iny
  lda ($04),y      ;get pitch of note
  sta notenum,x
  asl              ;pitch*2
  tay
  lda frequenzlo,y ;save the appropriate
  sta tempfreq     ;base frequency
  lda frequenzhi,y
  ldy tmpregofst
  sta $d401,y
  sta savefreqhi,x
  lda tempfreq
  sta $d400,y
  sta savefreqlo,x
  jmp a6

appendnote =*

  dec appendfl     ;clever eh?


;fetch all the initial values from the
;instrument data structure

a6:
  ldy tmpregofst
  lda instrnr,x    ;instr num
  stx tempstore
  asl              ;instr num*8
  asl
  asl
  tax

  lda instr+2,x    ;get control reg val
  sta tempctrl
  lda instr+2,x
  and appendfl     ;implement append
  sta $d404,y

  lda instr+0,x    ;get pulse width lo
  sta $d402,y

  lda instr+1,x    ;get pulse width hi
  sta $d403,y

  lda instr+3,x    ;get attack/decay
  sta $d405,y

  lda instr+4,x    ;get sustain/release
  sta $d406,y

  ldx tempstore    ;save control reg val
  lda tempctrl
  sta voicectrl,x


;4th byte checks for the end of pattern
;if eop found, inc the position and
;reset patoffset for new pattern

  inc patoffset,x  ;preview 4th byte
  ldy patoffset,x
  lda ($04),y

  cmp #$fe         ;check for eop *
  bne a7

  lda #$00         ;end of pat reached
  sta patoffset,x  ;inc position for
  inc posoffset,x  ;the next time

a7:
  jmp loopcont


;==========
;soundwork
;the instrument and effects processing
;routine when no new note was needed

soundwork =*

;release routine
;set off a release when the length of
;the note is exceeded
;bit4 of the 1st note-byte can specify
;for no release

  ldy tmpregofst

  ;lda savelnthcc,x ;check for no release
  ;and #$20         ;specified
  ;bne vibrato

  jmp vibrato    ; *

  lda lengthleft,x ;check for length of
  bne vibrato      ;exceeded

  lda voicectrl,x  ;length exceeded so
  and #$fe         ;start the release
  sta $d404,y      ;and kill adsr
  lda #$00
  sta $d405,y
  sta $d406,y


;vibrato routine
;(does alot of work)

vibrato =*

  lda instrnr,x    ;instr num
  asl
  asl
  asl              ;instr num*8
  tay
  sty instnumby8   ;save instr num*8

  lda instr+7,y    ;get instr fx byte
  sta instrfx

  lda instr+6,y    ;get pulse speed
  sta pulsevalue

  lda instr+5,y    ;get vibrato depth
  sta vibrdepth
  beq pulsework    ;check for no vibrato

  lda counter      ;this is clever!!
  and #7           ;the counter's turned
  cmp #4           ;into an oscillating
  bcc a8           ;value (01233210)
  eor #7
a8:
  sta oscilatval

  lda notenum,x    ;get base note
  asl              ;note*2
  tay              ;get diff btw note
  sec              ;and note+1 frequency
  lda frequenzlo+2,y
  sbc frequenzlo,y
  sta tmpvdiflo
  lda frequenzhi+2,y
  sbc frequenzhi,y

a9:
  lsr              ;divide difference by
  ror tmpvdiflo    ;2 for each vibrdepth
  dec vibrdepth
  bpl a9
  sta tmpvdifhi

  lda frequenzlo,y ;save note frequency
  sta tmpvfrqlo
  lda frequenzhi,y
  sta tmpvfrqhi

  lda savelnthcc,x ;no vibrato if note
  and #$7f         ;length less than 8   *
  cmp #8
  bcc a11

  ldy oscilatval

a10:
  dey              ;depending on the osc
  bmi a11          ;value, add the vibr
  clc              ;freq that many times
  lda tmpvfrqlo    ;to the base freq
  adc tmpvdiflo
  sta tmpvfrqlo
  lda tmpvfrqhi
  adc tmpvdifhi
  sta tmpvfrqhi
  jmp a10

a11:
  ldy tmpregofst   ;save the final
  lda tmpvfrqlo    ;frequencies
  sta $d400,y
  lda tmpvfrqhi
  sta $d401,y


;pulse-width timbre routine
;depending on the control/speed byte in
;the instrument datastructure, the pulse
;width is of course inc/decremented to
;produce timbre

;strangely the delay value is also the
;size of the inc/decrements

pulsework =*

  lda pulsevalue   ;check for pulsework
  beq portamento   ;needed this instr

  ldy instnumby8
  and #$1f
  dec pulsedelay,x ;pulsedelay-1
  bpl portamento

  sta pulsedelay,x ;reset pulsedelay

  lda pulsevalue   ;restrict pulse speed
  and #$e0         ;from $00-$1f
  sta pulsespeed

  lda pulsedir,x   ;pulsedir 0 is up and
  bne pulsedown    ;1 is down

  lda pulsespeed   ;pulse width up
  clc
  adc instr+0,y    ;add the pulsespeed
  pha              ;to the pulse width
  lda instr+1,y
  adc #$00
  and #$0f
  pha
  cmp #$0e         ;go pulsedown when
  bne dumpulse     ;the pulse value
  inc pulsedir,x   ;reaches max ($0exx)
  jmp dumpulse

pulsedown =*

  sec              ;pulse width down
  lda instr+0,y
  sbc pulsespeed   ;sub the pulsespeed
  pha              ;from the pulse width
  lda instr+1,y
  sbc #$00
  and #$0f
  pha
  cmp #$08         ;go pulseup when
  bne dumpulse     ;the pulse value
  dec pulsedir,x   ;reaches min ($08xx)

dumpulse =*

  stx tempstore    ;dump pulse width to
  ldx tmpregofst   ;chip and back into
  pla              ;the instr data str
  sta instr+1,y
  sta $d403,x
  pla
  sta instr+0,y
  sta $d402,x
  ldx tempstore


;portamento routine
;portamento comes from the second byte
;if it's a negative value

portamento =*

  ldy tmpregofst
  lda portaval,x   ;check for portamento
  beq drums        ;none

  and #$7e         ;toad unwanted bits
  sta tempstore

  lda portaval,x   ;bit0 signals up/down
  and #$01
  beq portup

  sec              ;portamento down
  lda savefreqlo,x ;sub portaval from
  sbc tempstore    ;current frequency
  sta savefreqlo,x
  sta $d400,y
  lda savefreqhi,x
  sbc #$00         ;(word arithmetic)
  sta savefreqhi,x
  sta $d401,y
  jmp drums

portup =*

  clc              ;portamento up
  lda savefreqlo,x ;add portval to
  adc tempstore    ;current frequency
  sta savefreqlo,x
  sta $d400,y
  lda savefreqhi,x
  adc #$00
  sta savefreqhi,x
  sta $d401,y


;bit0 instrfx are the drum routines
;the actual drum timbre depends on the
;crtl register value for the instrument:
;ctrlreg 0 is always noise
;ctrlreg x is noise for 1st vbl and x
;from then on

;see that the drum is made by rapid hi
;to low frequency slide with fast attack
;and decay

drums =*

  lda instrfx      ;check if drums
  and #$01         ;needed this instr
  beq skydive

  lda savefreqhi,x ;don't bother if freq
  beq skydive      ;can't go any lower

  lda lengthleft,x ;or if the note has
  beq skydive      ;finished

  lda savelnthcc,x ;check if this is the
  and #$7f         ;first vbl for this *
  sec              ;instrument-note
  sbc #$01
  cmp lengthleft,x
  ldy tmpregofst
  bcc firstime

  lda savefreqhi,x ;not the first time
  dec savefreqhi,x ;so dec freqhi for
  sta $d401,y      ;drum sound

  lda voicectrl,x  ;if ctrlreg is 0 then
  and #$fe         ;noise is used always
  bne dumpctrl

firstime =*

  lda savefreqhi,x ;noise is used for
  sta $d401,y      ;the first vbl also
  lda #$80         ;(set noise)

dumpctrl =*

  sta $d404,y


;bit1 instrfx is the skydive
;a long portamento-down from the note
;to zerofreq

skydive =*

  lda instrfx      ;check if skydive
  and #$02         ;needed this instr
  beq octarp

  lda counter      ;every 2nd vbl
  and #$01
  beq octarp

  lda savefreqhi,x ;check if skydive
  beq octarp        ;already complete

  dec savefreqhi,x ;decr and save the
  ldy tmpregofst   ;high byte freq
  sta $d401,y


;bit2 instrfx is an octave arpeggio
;pretty tame huh?

octarp =*

  lda instrfx      ;check if arpt needed
  and #$04
  beq loopcont

  lda counter      ;only 2 arpt values
  and #$01
  beq a12

  lda notenum,x    ;odd, note+12
  clc
  adc #$0c
  jmp a13

a12:
  lda notenum,x    ;even, note

a13:
  asl              ;dump the corresponding
  tay              ;frequencies
  lda frequenzlo,y
  sta tempfreq
  lda frequenzhi,y
  ldy tmpregofst
  sta $d401,y
  lda tempfreq
  sta $d400,y


;==========
;end of dbf loop

loopcont =*

  dex              ;dbf mainloop
  bmi musicend
  jmp mainloop

musicend =*

  rts


;====================================
;frequenz data
;====================================

frequenzlo: .byte $16
frequenzhi: .byte $01
 .byte $27,$01,$38,$01,$4b,$01
 .byte $5f,$01,$73,$01,$8a,$01,$a1,$01
 .byte $ba,$01,$d4,$01,$f0,$01,$0e,$02
 .byte $2d,$02,$4e,$02,$71,$02,$96,$02
 .byte $bd,$02,$e7,$02,$13,$03,$42,$03
 .byte $74,$03,$a9,$03,$e0,$03,$1b,$04
 .byte $5a,$04,$9b,$04,$e2,$04,$2c,$05
 .byte $7b,$05,$ce,$05,$27,$06,$85,$06
 .byte $e8,$06,$51,$07,$c1,$07,$37,$08
 .byte $b4,$08,$37,$09,$c4,$09,$57,$0a
 .byte $f5,$0a,$9c,$0b,$4e,$0c,$09,$0d
 .byte $d0,$0d,$a3,$0e,$82,$0f,$6e,$10
 .byte $68,$11,$6e,$12,$88,$13,$af,$14
 .byte $eb,$15,$39,$17,$9c,$18,$13,$1a
 .byte $a1,$1b,$46,$1d,$04,$1f,$dc,$20
 .byte $d0,$22,$dc,$24,$10,$27,$5e,$29
 .byte $d6,$2b,$72,$2e,$38,$31,$26,$34
 .byte $42,$37,$8c,$3a,$08,$3e,$b8,$41
 .byte $a0,$45,$b8,$49,$20,$4e,$bc,$52
 .byte $ac,$57,$e4,$5c,$70,$62,$4c,$68
 .byte $84,$6e,$18,$75,$10,$7c,$70,$83
 .byte $40,$8b,$70,$93,$40,$9c,$78,$a5
 .byte $58,$af,$c8,$b9,$e0,$c4,$98,$d0
 .byte $08,$dd,$30,$ea,$20,$f8,$2e,$fd


regoffsets: .byte $00,$07,$0e
tmpregofst: .byte $00
posoffset:  .byte $00,$00,$00
patoffset:  .byte $00,$00,$00
lengthleft: .byte $00,$00,$00
savelnthcc: .byte $00,$00,$00
voicectrl:  .byte $00,$00,$00
notenum:    .byte $00,$00,$00
instrnr:    .byte $00,$00,$00
appendfl:   .byte $00
templnthcc: .byte $00
tempfreq:   .byte $00
tempstore:  .byte $00
tempctrl:   .byte $00
vibrdepth:  .byte $00
pulsevalue: .byte $00
tmpvdiflo:  .byte $00
tmpvdifhi:  .byte $00
tmpvfrqlo:  .byte $00
tmpvfrqhi:  .byte $00
oscilatval: .byte $00
pulsedelay: .byte $00,$00,$00
pulsedir:   .byte $00,$00,$00
speed:      .byte $00
resetspd:   .byte $03;  01
instnumby8: .byte $00
mstatus:    .byte $c0
savefreqhi: .byte $00,$00,$00
savefreqlo: .byte $00,$00,$00
portaval:   .byte $00,$00,$00
instrfx:    .byte $00
pulsespeed: .byte $00
counter:    .byte $00
currtrkhi:  .byte $00,$00,$00
currtrklo:  .byte $00,$00,$00
savegate:   .byte $00,$00,$00

;====================================
;driller main theme
;====================================

songs =*
 .byte <drillermaintr1
 .byte <drillermaintr2
 .byte <drillermaintr3
 .byte >drillermaintr1
 .byte >drillermaintr2
 .byte >drillermaintr3


;====================================
;pointers to the patterns

;low pointers
patptl =*
 .byte <ptn00
 .byte <ptn01
 .byte <ptn02
 .byte <ptn03
 .byte <ptn04
 .byte <ptn05
 .byte <ptn06
 .byte <ptn07
 .byte <ptn08
 .byte <ptn09
 .byte <ptn0A
 .byte <ptn0B
 .byte <ptn0C
 .byte <ptn0D
 .byte <ptn0E
 .byte <ptn0F
 .byte <ptn10
 .byte <ptn11
 .byte <ptn12
 .byte <ptn13
 .byte <ptn14
 .byte <ptn15
 .byte <ptn16
 .byte <ptn17
 .byte <ptn18
 .byte <ptn19
 .byte <ptn1A
 .byte <ptn1B
 .byte <ptn1C
 .byte <ptn1D
 .byte <ptn1E
 .byte <ptn1F
 .byte <ptn20
 .byte <ptn21
 .byte <ptn22
 .byte <ptn23
 .byte <ptn24
 .byte <ptn25
 .byte <ptn26
 .byte <ptn27
 .byte <ptn28
 .byte <ptn29
 .byte <ptn2A
 .byte <ptn2B
 .byte <ptn2C
 .byte <ptn2D
 .byte <ptn2E

;high pointers
patpth =*
 .byte >ptn00
 .byte >ptn01
 .byte >ptn02
 .byte >ptn03
 .byte >ptn04
 .byte >ptn05
 .byte >ptn06
 .byte >ptn07
 .byte >ptn08
 .byte >ptn09
 .byte >ptn0A
 .byte >ptn0B
 .byte >ptn0C
 .byte >ptn0D
 .byte >ptn0E
 .byte >ptn0F
 .byte >ptn10
 .byte >ptn11
 .byte >ptn12
 .byte >ptn13
 .byte >ptn14
 .byte >ptn15
 .byte >ptn16
 .byte >ptn17
 .byte >ptn18
 .byte >ptn19
 .byte >ptn1A
 .byte >ptn1B
 .byte >ptn1C
 .byte >ptn1D
 .byte >ptn1E
 .byte >ptn1F
 .byte >ptn20
 .byte >ptn21
 .byte >ptn22
 .byte >ptn23
 .byte >ptn24
 .byte >ptn25
 .byte >ptn26
 .byte >ptn27
 .byte >ptn28
 .byte >ptn29
 .byte >ptn2A
 .byte >ptn2B
 .byte >ptn2C
 .byte >ptn2D
 .byte >ptn2E

;====================================
;tracks
;====================================

;track1
drillermaintr1 =*
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00

  .byte $01, $01, $2B, $09; 07->2B
  .byte $09, $09, $01, $07
  .byte $07, $0F, $0F, $0F
  .byte $0F, $0F, $0F, $03
  .byte $03, $0F, $0F, $13
  .byte $13, $0F, $13, $0F
  .byte $13, $0F, $13, $0F
  .byte $13, $0F, $0F, $0F
  .byte $0F, $0F, $0F, $0F
  .byte $0F, $0F, $0F, $0F
  .byte $0F, $0F, $0F, $0F
  .byte $0F, $0F, $0F, $0F
  .byte $0F, $0F, $0F, $0F
  .byte $0F, $0F, $1B, $1D
  .byte $1E, $0F, $1B, $1D
  .byte $1E, $0F, $1B, $1D
  .byte $1E, $12, $12, $12
  .byte $12, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $08, $08, $28
  .byte $00, $00, $00, $00
  .byte $00, $FE

;track2
drillermaintr2 =*

  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00

  .byte $03, $03, $08, $0A
  .byte $0D, $0D, $0D, $0D
  .byte $2A, $2B, $0E, $0E; 08->2A 07->2B
  .byte $0E, $0E, $0E, $0E
  .byte $0E, $0E, $05, $12
  .byte $12, $12, $12, $14
  .byte $15, $14, $15, $14
  .byte $15, $14, $15, $2A; 08->2A
  .byte $17, $17, $17, $17
  .byte $17, $17, $17, $17
  .byte $17, $17, $17, $17
  .byte $07, $2B, $1F, $1F; 07->2B
  .byte $1F, $1F, $07, $07
  .byte $00, $00, $25, $2D; 25->2D
  .byte $26, $25, $27, $27
  .byte $27, $27, $27, $27
  .byte $27, $27, $06, $06
  .byte $06, $06, $06, $06
  .byte $06, $06, $06, $2E; 06->2E
  .byte $28, $00, $00, $00
  .byte $00, $FE

;track3
drillermaintr3 =*

  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00
  ;.byte $00, $00, $00, $00

  .byte $00, $00, $00, $00
  .byte $04, $06, $06, $0C
  .byte $0B, $0C, $0B, $0C
  .byte $0B, $06, $06, $06
  .byte $06, $06, $06, $06
  .byte $06, $06, $06, $06
  .byte $06, $06, $06, $0F
  .byte $0F, $10, $11, $0E
  .byte $0E, $0E, $0E, $0E
  .byte $0E, $0E, $0E, $0E
  .byte $0E, $0E, $0E, $16
  .byte $07, $07, $07, $18
  .byte $19, $19, $1A, $1A
  .byte $08, $08, $1C, $08
  .byte $08, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $07, $07, $0F
  .byte $0F, $0F, $0F, $29
  .byte $00, $00, $00, $00
  .byte $FE


;====================================
;patterns
;====================================

ptn00 =*
  ;.byte $FD, $3F
  ;.byte $FA, $04
  ;.byte $00

  .byte $BF, $04, $00
  .byte $FE

ptn01 =*
  ;.byte $FA, $01
  ;.byte $FD, $3F
  ;.byte $23, $1F, $22, $1E

  .byte $BF, $01, $23
  .byte $3F,      $1F
  .byte $3F,      $22
  .byte $82               ; made gate=0
  .byte $3F,      $1E

  .byte $FE

ptn03 =*
  ;.byte $FA, $01
  ;.byte $FD, $3F
  ;.byte $17, $13, $16, $12

  .byte $BF, $01, $17
  .byte $3F,      $13
  .byte $3F,      $16
  .byte $82                ; made get=0
  .byte $3F,      $12

  .byte $FE


ptn02 =*
   ;.byte $FD, $0F
   ;.byte $FA, $04
   ;.byte $00

   .byte $8F, $04, $00
   .byte $FE

ptn04 =*
   ;.byte $FA, $02
   ;.byte $FD, $7F
   ;.byte $25, $25

   .byte $FF, $02, $25
   .byte $82
   .byte $7F,      $25
   .byte $FE

ptn05 =*
   ;.byte $FA, $0E
   ;.byte $FD, $3F
   ;.byte $2F, $2B, $2E

   .byte $BF, $0E, $2F
   .byte $3F,      $2B
   .byte $3F,      $2E

   ;.byte $FC, $20
   ;.byte $2A

   .byte $84              ; gate = 0 before end
   .byte $BF, $C0, $2A    ; positive portamento
   .byte $FE

ptn06 =*
   ;.byte $FA, $06
   ;.byte $FD, $01
   ;.byte $42, $3B, $3B, $42

   .byte $81, $06, $42
   .byte $01,      $3B
   .byte $01,      $3B
   .byte $01,      $42

   ;.byte $3B, $3B, $43, $3B

   .byte $01,      $3B
   .byte $01,      $3B
   .byte $01,      $43
   .byte $01,      $3B

   ;.byte $42, $3B, $3B, $42

   .byte $01,      $42
   .byte $01,      $3B
   .byte $01,      $3B
   .byte $01,      $42

   ;.byte $3B, $3B, $43, $3B

   .byte $01,      $3B
   .byte $01,      $3B
   .byte $01,      $43
   .byte $01,      $3B

   ;.byte $42, $3B, $3B, $42

   .byte $01,      $42
   .byte $01,      $3B
   .byte $01,      $3B
   .byte $01,      $42

   ;.byte $3B, $3B, $43, $3B

   .byte $01,      $3B
   .byte $01,      $3B
   .byte $01,      $43
   .byte $01,      $3B

   ;.byte $42, $3B, $3B, $42

   .byte $01,      $42
   .byte $01,      $3B
   .byte $01,      $3B
   .byte $01,      $42

   ;.byte $3B, $3B, $43, $3B

   .byte $01,      $3B
   .byte $01,      $3B
   .byte $01,      $43
   .byte $01,      $3B
   .byte $FE

ptn07 =*
   ;.byte $FA, $01
   ;.byte $FD, $7F
   ;.byte $23
   .byte $82               ; made gate=0 before end
   .byte $FF, $16, $23     ; not 01: I must have a less S level for this long sound
   .byte $FE

ptn08 =*
   ;.byte $FA, $01
   ;.byte $FD, $7F
   ;.byte $17, $00

   .byte $82               ; made gate=0
   .byte $FF, $01, $17
     ; .byte $FF, $04, $00
   .byte $FF, $01, $17     ; without release
   .byte $FE

ptn09 =*
   ;.byte $FA, $09
   ;.byte $FD, $1F
   ;.byte $17, $13, $12, $0F

   .byte $80+$1F, $09, $17
   .byte $1F,          $13
   .byte $1F,          $12
   .byte $1F,          $0F
   .byte $FE

ptn0A =*
   ;.byte $FA, $08
   ;.byte $FD, $0F
   ;.byte $3E, $39

   .byte $8F, $08, $3E
   .byte $0F,      $39

   ;.byte $FD, $1F
   ;.byte $3B

   .byte $1F, $3B

   ;.byte $FD, $0F
   ;.byte $3D, $3B

   .byte $0F, $3D
   .byte $0F, $3B

   ;.byte $FD, $1F
   ;.byte $3A

   .byte $1F, $3A

   ;.byte $FD, $7F
   ;.byte $FB, $01
   ;.byte $2F

   .byte $82
   .byte $FF, $83, $2F   ; negative portamento
   .byte $FE

ptn0B =*
   ;.byte $FA, $06
   ;.byte $FD, $01
   ;.byte $3D, $36, $36, $3D

   .byte $81, $06, $3D
   .byte $01,      $36
   .byte $01,      $36
   .byte $01,      $3D

   ;.byte $36, $36, $3E, $36

   .byte $01,      $36
   .byte $01,      $36
   .byte $01,      $3E
   .byte $01,      $36

   ;.byte $3D, $36, $36, $3D

   .byte $01,      $3D
   .byte $01,      $36
   .byte $01,      $36
   .byte $01,      $3D

   ;.byte $36, $36, $3E, $36

   .byte $01,      $36
   .byte $01,      $36
   .byte $01,      $3E
   .byte $01,      $36

   ;.byte $3A, $33, $33, $3A

   .byte $01,      $3A
   .byte $01,      $33
   .byte $01,      $33
   .byte $01,      $3A

   ;.byte $33, $33, $3B, $33

   .byte $01,      $33
   .byte $01,      $33
   .byte $01,      $3B
   .byte $01,      $33

   ;.byte $3A, $33, $33, $3A

   .byte $01,      $3A
   .byte $01,      $33
   .byte $01,      $33
   .byte $01,      $3A

   ;.byte $33, $33, $3B, $33

   .byte $01,      $33
   .byte $01,      $33
   .byte $01,      $3B
   .byte $01,      $33
   .byte $FE

ptn0C =*
  ;.byte $FA, $06
  ;.byte $FD, $01
  ;.byte $42, $3B, $3B, $42

  .byte $81, $06, $42
  .byte $01,      $3B
  .byte $01,      $3B
  .byte $01,      $42

  ;.byte $3B, $3B, $43, $3B

  .byte $01,      $3B
  .byte $01,      $3B
  .byte $01,      $43
  .byte $01,      $3B

  ;.byte $42, $3B, $3B, $42

  .byte $01,      $42
  .byte $01,      $3B
  .byte $01,      $3B
  .byte $01,      $42

  ;.byte $3B, $3B, $43, $3B

  .byte $01,      $3B
  .byte $01,      $3B
  .byte $01,      $43
  .byte $01,      $3B

  ;.byte $3E, $37, $37, $3E

  .byte $01,      $3E
  .byte $01,      $37
  .byte $01,      $37
  .byte $01,      $3E

  ;.byte $37, $37, $3F, $37

  .byte $01,      $37
  .byte $01,      $37
  .byte $01,      $3F
  .byte $01,      $37

  ;.byte $3E, $37, $37, $3E

  .byte $01,      $3E
  .byte $01,      $37
  .byte $01,      $37
  .byte $01,      $3E

  ;.byte $37, $37, $3F, $37

  .byte $01,      $37
  .byte $01,      $37
  .byte $01,      $3F
  .byte $01,      $37
  .byte $FE

ptn0D =*
  ;.byte $FA, $0A
  ;.byte $FD, $01
  ;.byte $3B, $3A, $39, $38

  .byte $81, $0A, $3B
  .byte $01,      $3A
  .byte $01,      $39
  .byte $01,      $38

  ;.byte $39, $3A, $3B, $3A

  .byte $01,      $39
  .byte $01,      $3A
  .byte $01,      $3B
  .byte $01,      $3A

  ;.byte $39, $38, $39, $3A

  .byte $01,      $39
  .byte $01,      $38
  .byte $01,      $39
  .byte $01,      $3A

  ;.byte $3B, $3A, $39, $38

  .byte $01,      $3B
  .byte $01,      $3A
  .byte $01,      $39
  .byte $01,      $38

  ;.byte $39, $3A, $3B, $3A

  .byte $01,      $39
  .byte $01,      $3A
  .byte $01,      $3B
  .byte $01,      $3A

  ;.byte $39, $38, $39, $3A

  .byte $01,      $39
  .byte $01,      $38
  .byte $01,      $39
  .byte $01,      $3A

  ;.byte $3B, $3A, $39, $38

  .byte $01,      $3B
  .byte $01,      $3A
  .byte $01,      $39
  .byte $01,      $38

  ;.byte $39, $3A, $3B, $3A

  .byte $01,      $39
  .byte $01,      $3A
  .byte $01,      $3B
  .byte $82
  .byte $01,      $3A
  .byte $FE

ptn0E =*
  ;.byte $FA, $07
  ;.byte $FD, $01
  ;.byte $2D

  .byte $81, $07, $2D

  ;.byte $FD, $03
  ;.byte $2D

  .byte $03, $2D

  ;.byte $FD, $0D
  ;.byte $2D

  .byte $0D, $2D

  ;.byte $FD, $03
  ;.byte $2D

  .byte $03, $2D

  ;.byte $FD, $07
  ;.byte $FA, $00
  ;.byte $2D

  .byte $84               ; gate = 0 before end
  .byte $87, $00, $2D

  ;.byte $FA, $07
  ;.byte $FD, $01
  ;.byte $2D

  .byte $81, $07, $2D

  ;.byte $FD, $03
  ;.byte $2D

  .byte $03, $2D

  ;.byte $FD, $0D
  ;.byte $2D

  .byte $0D, $2D

  ;.byte $FD, $03
  ;.byte $2D

  .byte $03, $2D

  ;.byte $FD, $07
  ;.byte $FA, $00
  ;.byte $2D

  .byte $84                ; gate=0 before end
  .byte $87, $00, $2D
  .byte $FE

ptn0F =*
  ;.byte $FA, $0B
  ;.byte $FD, $01
  ;.byte $23, $23, $23, $23

  .byte $81,$0B, $23
  .byte $01,     $23
  .byte $01,     $23
  .byte $01,     $23

  ;.byte $23, $23, $23, $23
  .byte $01,     $23
  .byte $01,     $23
  .byte $01,     $23
  .byte $01,     $23

  ;.byte $23, $23, $23, $23

  .byte $01,     $23
  .byte $01,     $23
  .byte $01,     $23
  .byte $01,     $23

  ;.byte $23, $23, $23, $23

  .byte $01,     $23
  .byte $01,     $23
  .byte $01,     $23
  .byte $01,     $23

  ;.byte $23, $23, $23, $23

  .byte $01,     $23
  .byte $01,     $23
  .byte $01,     $23
  .byte $01,     $23

  ;.byte $23, $23, $23, $23

  .byte $01,     $23
  .byte $01,     $23
  .byte $01,     $23
  .byte $01,     $23

  ;.byte $23, $23, $23, $23

  .byte $01,     $23
  .byte $01,     $23
  .byte $01,     $23
  .byte $01,     $23

  ;.byte $23, $23, $23, $23

  .byte $01,     $23
  .byte $01,     $23
  .byte $01,     $23
  .byte $01,     $23
  .byte $FE

ptn10 =*
  ;.byte $FA, $0B
  ;.byte $FD, $01
  ;.byte $22, $22, $22, $22

  .byte $81,$0B, $22
  .byte $01,     $22
  .byte $01,     $22
  .byte $01,     $22


  ;.byte $22, $22, $22, $22

  .byte $01,     $22
  .byte $01,     $22
  .byte $01,     $22
  .byte $01,     $22

  ;.byte $22, $22, $22, $22

  .byte $01,     $22
  .byte $01,     $22
  .byte $01,     $22
  .byte $01,     $22

  ;.byte $22, $22, $22, $22

  .byte $01,     $22
  .byte $01,     $22
  .byte $01,     $22
  .byte $01,     $22

  ;.byte $22, $22, $22, $22

  .byte $01,     $22
  .byte $01,     $22
  .byte $01,     $22
  .byte $01,     $22

  ;.byte $22, $22, $22, $22

  .byte $01,     $22
  .byte $01,     $22
  .byte $01,     $22
  .byte $01,     $22

  ;.byte $22, $22, $22, $22

  .byte $01,     $22
  .byte $01,     $22
  .byte $01,     $22
  .byte $01,     $22

  ;.byte $22, $22, $22, $22

  .byte $01,     $22
  .byte $01,     $22
  .byte $01,     $22
  .byte $01,     $22
  .byte $FE

ptn11 =*
   ;.byte $FA, $0B
   ;.byte $FD, $01
   ;.byte $25, $25, $25, $25

   .byte $81, $0B, $25
   .byte $01,      $25
   .byte $01,      $25
   .byte $01,      $25

   ;.byte $25, $25, $25, $25

   .byte $01,      $25
   .byte $01,      $25
   .byte $01,      $25
   .byte $01,      $25

   ;.byte $25, $25, $25, $25

   .byte $01,      $25
   .byte $01,      $25
   .byte $01,      $25
   .byte $01,      $25

   ;.byte $25, $25, $25, $25

   .byte $01,      $25
   .byte $01,      $25
   .byte $01,      $25
   .byte $01,      $25

   ;.byte $25, $25, $25, $25

   .byte $01,      $25
   .byte $01,      $25
   .byte $01,      $25
   .byte $01,      $25

   ;.byte $25, $25, $25, $25

   .byte $01,      $25
   .byte $01,      $25
   .byte $01,      $25
   .byte $01,      $25

   ;.byte $25, $25, $25, $25

   .byte $01,      $25
   .byte $01,      $25
   .byte $01,      $25
   .byte $01,      $25

   ;.byte $25, $25, $25, $25

   .byte $01,      $25
   .byte $01,      $25
   .byte $01,      $25
   .byte $01,      $25
   .byte $FE

ptn12 =*
  ;.byte $FA, $0A
  ;.byte $FD, $01
  ;.byte $3B, $37, $36, $34

  .byte $81, $0A, $3B
  .byte $01,      $37
  .byte $01,      $36
  .byte $01,      $34

  ;.byte $3B, $37, $36, $34

  .byte $01,      $3B
  .byte $01,      $37
  .byte $01,      $36
  .byte $01,      $34

  ;.byte $3B, $37, $36, $34

  .byte $01,      $3B
  .byte $01,      $37
  .byte $01,      $36
  .byte $01,      $34

  ;.byte $3B, $37, $36, $34

  .byte $01,      $3B
  .byte $01,      $37
  .byte $01,      $36
  .byte $01,      $34

  ;.byte $3B, $37, $36, $34

  .byte $01,      $3B
  .byte $01,      $37
  .byte $01,      $36
  .byte $01,      $34

  ;.byte $3B, $37, $36, $34

  .byte $01,      $3B
  .byte $01,      $37
  .byte $01,      $36
  .byte $01,      $34

  ;.byte $3B, $37, $36, $34

  .byte $01,      $3B
  .byte $01,      $37
  .byte $01,      $36
  .byte $01,      $34

  ;.byte $3B, $37, $36, $34

  .byte $01,      $3B
  .byte $01,      $37
  .byte $01,      $36
  .byte $01,      $34
  .byte $FE

ptn13 =*
  ;.byte $FA, $0B
  ;.byte $FD, $01
  ;.byte $1F, $1F, $1F, $1F

  .byte $81, $0B, $1F
  .byte $01,      $1F
  .byte $01,      $1F
  .byte $01,      $1F

  ;.byte $1F, $1F, $1F, $1F

  .byte $01,      $1F
  .byte $01,      $1F
  .byte $01,      $1F
  .byte $01,      $1F

  ;.byte $1F, $1F, $1F, $1F

  .byte $01,      $1F
  .byte $01,      $1F
  .byte $01,      $1F
  .byte $01,      $1F
  
  ;.byte $1F, $1F, $1F, $1F
  
  .byte $01,      $1F
  .byte $01,      $1F
  .byte $01,      $1F
  .byte $01,      $1F

  ;.byte $1F, $1F, $1F, $1F
  
  .byte $01,      $1F
  .byte $01,      $1F
  .byte $01,      $1F
  .byte $01,      $1F

  ;.byte $1F, $1F, $1F, $1F
  
  .byte $01,      $1F
  .byte $01,      $1F
  .byte $01,      $1F
  .byte $01,      $1F

  ;.byte $1F, $1F, $1F, $1F

  .byte $01,      $1F
  .byte $01,      $1F
  .byte $01,      $1F
  .byte $01,      $1F

  ;.byte $1F, $1F, $1F, $1F

  .byte $01,      $1F
  .byte $01,      $1F
  .byte $01,      $1F
  .byte $01,      $1F
  .byte $FE

ptn14 =*
  ;.byte $FA, $06
  ;.byte $FD, $01
  ;.byte $3F, $3B, $36, $3F

  .byte $81, $06, $3F
  .byte $01,      $3B
  .byte $01,      $36
  .byte $01,      $3F

  ;.byte $3B, $36, $3F, $3B

  .byte $01,      $3B
  .byte $01,      $36
  .byte $01,      $3F
  .byte $01,      $3B

  ;.byte $3F, $3B, $36, $3F

  .byte $01,      $3F
  .byte $01,      $3B
  .byte $01,      $36
  .byte $01,      $3F

  ;.byte $3B, $36, $3F, $3B

  .byte $01,      $3B
  .byte $01,      $36
  .byte $01,      $3F
  .byte $01,      $3B

  ;.byte $3F, $3B, $36, $3F

  .byte $01,      $3F
  .byte $01,      $3B
  .byte $01,      $36
  .byte $01,      $3F

  ;.byte $3B, $36, $3F, $3B

  .byte $01,      $3B
  .byte $01,      $36
  .byte $01,      $3F
  .byte $01,      $3B

  ;.byte $3F, $3B, $36, $3F

  .byte $01,      $3F
  .byte $01,      $3B
  .byte $01,      $36
  .byte $01,      $3F

  ;.byte $3B, $36, $3F, $3B

  .byte $01,      $3B
  .byte $01,      $36
  .byte $01,      $3F
  .byte $01,      $3B
  .byte $FE

ptn15 =*
  ;.byte $FA, $06
  ;.byte $FD, $01
  ;.byte $3E, $3B, $37, $3E

  .byte $81, $06, $3E
  .byte $01,      $3B
  .byte $01,      $37
  .byte $01,      $3E

  ;.byte $3B, $37, $3E, $3B

  .byte $01,      $3B
  .byte $01,      $37
  .byte $01,      $3E
  .byte $01,      $3B

  ;.byte $3E, $3B, $37, $3E

  .byte $01,      $3E
  .byte $01,      $3B
  .byte $01,      $37
  .byte $01,      $3E

  ;.byte $3B, $37, $3E, $3B

  .byte $01,      $3B
  .byte $01,      $37
  .byte $01,      $3E
  .byte $01,      $3B

  ;.byte $3E, $3B, $37, $3E

  .byte $01,      $3E
  .byte $01,      $3B
  .byte $01,      $37
  .byte $01,      $3E

  ;.byte $3B, $37, $3E, $3B

  .byte $01,      $3B
  .byte $01,      $37
  .byte $01,      $3E
  .byte $01,      $3B

  ;.byte $3E, $3B, $37, $3E

  .byte $01,      $3E
  .byte $01,      $3B
  .byte $01,      $37
  .byte $01,      $3E

  ;.byte $3B, $37, $3E, $3B

  .byte $01,      $3B
  .byte $01,      $37
  .byte $01,      $3E
  .byte $01,      $3B
  .byte $FE

ptn16 =*
  ;.byte $FA, $0D
  ;.byte $FD, $1F
  ;.byte $37, $36, $39, $37

  .byte $9F, $0D, $37
  .byte $1F,      $36
  .byte $1F,      $39
  .byte $1F,      $37

  ;.byte $36, $2F, $2F, $32

  .byte $1F, $36
  .byte $1F, $2F
  .byte $1F, $2F
  .byte $1F, $32
  .byte $FE

ptn17 =*
  ;.byte $FA, $10
  ;.byte $FD, $01
  ;.byte $23, $23, $2A, $2A

  .byte $81, $10, $23
  .byte $01,      $23
  .byte $01,      $2A
  .byte $01,      $2A

  ;.byte $28, $28, $2A, $2A

  .byte $01,      $28
  .byte $01,      $28
  .byte $01,      $2A
  .byte $01,      $2A

  ;.byte $26, $26, $2A, $2A

  .byte $01,      $26
  .byte $01,      $26
  .byte $01,      $2A
  .byte $01,      $2A

  ;.byte $28, $28, $2A, $2A

  .byte $01,      $28
  .byte $01,      $28
  .byte $01,      $2A
  .byte $01,      $2A

  ;.byte $23, $23, $2A, $2A

  .byte $01,      $23
  .byte $01,      $23
  .byte $01,      $2A
  .byte $01,      $2A

  ;.byte $28, $28, $2A, $2A

  .byte $01,      $28
  .byte $01,      $28
  .byte $01,      $2A
  .byte $01,      $2A

  ;.byte $26, $26, $2A, $2A

  .byte $01,      $26
  .byte $01,      $26
  .byte $01,      $2A
  .byte $01,      $2A

  ;.byte $28, $28, $2A, $2A

  .byte $01,      $28
  .byte $01,      $28
  .byte $01,      $2A
  .byte $01,      $2A
  .byte $FE

ptn18 =*
  ;.byte $FA, $13
  ;.byte $FD, $07
  ;.byte $FC, $37, $45

  .byte $80, $13, $45   ; a patch
  .byte $86, $EE, $45   ; positive portamento


  ;.byte $FD, $2F
  ;.byte $47

  .byte $2F, $47

  ;.byte $FD, $07
  ;.byte $FB, $7F, $47

  .byte $87, $FF, $47  ; negative portamento

  ;.byte $FD, $37
  ;.byte $42

  .byte $37, $42

  ;.byte $FD, $07
  ;.byte $FB, $80
  ;.byte $42

  .byte $87, $C1, $42  ; negative portamento
  .byte $FE

ptn19 =*
  ;.byte $FA, $13
  ;.byte $FD, $1F
  ;.byte $3B

  .byte $9F, $13, $3B

  ;.byte $FD, $0F
  ;.byte $39, $37

  .byte $0F, $39
  .byte $0F, $37

  ;.byte $FD, $3F
  ;.byte $36

  .byte $3F, $36
  .byte $FE

ptn1A =*
  ;.byte $FA, $13
  ;.byte $FD, $1F
  ;.byte $34

  .byte $9F, $13, $34

  ;.byte $FD, $0F
  ;.byte $32, $31

  .byte $0F, $32
  .byte $0F, $31

  ;.byte $FD, $3F
  ;.byte $2F

  .byte $3F, $2F
  .byte $FE

ptn1B =*
  ;.byte $FA, $0B
  ;.byte $FD, $01
  ;.byte $1B, $1B, $1B, $1B

  .byte $81, $0B, $1B
  .byte $01,      $1B
  .byte $01,      $1B
  .byte $01,      $1B

  ;.byte $1B, $1B, $1B, $1B

  .byte $01,      $1B
  .byte $01,      $1B
  .byte $01,      $1B
  .byte $01,      $1B

  ;.byte $1B, $1B, $1B, $1B

  .byte $01,      $1B
  .byte $01,      $1B
  .byte $01,      $1B
  .byte $01,      $1B

  ;.byte $1B, $1B, $1B, $1B

  .byte $01,      $1B
  .byte $01,      $1B
  .byte $01,      $1B
  .byte $01,      $1B

  ;.byte $1B, $1B, $1B, $1B

  .byte $01,      $1B
  .byte $01,      $1B
  .byte $01,      $1B
  .byte $01,      $1B

  ;.byte $1B, $1B, $1B, $1B

  .byte $01,      $1B
  .byte $01,      $1B
  .byte $01,      $1B
  .byte $01,      $1B

  ;.byte $1B, $1B, $1B, $1B

  .byte $01,      $1B
  .byte $01,      $1B
  .byte $01,      $1B
  .byte $01,      $1B

  ;.byte $1B, $1B, $1B, $1B

  .byte $01,      $1B
  .byte $01,      $1B
  .byte $01,      $1B
  .byte $01,      $1B
  .byte $FE

ptn1C =*
  ;.byte $FA, $01
  ;.byte $FD, $1F
  ;.byte $3B

  .byte $9F, $01, $3B

  ;.byte $FD, $0F
  ;.byte $3A, $36

  .byte $0F, $3A
  .byte $0F, $36

  ;.byte $FD, $2F
  ;.byte $36

  .byte $2F, $36

  ;.byte $FD, $0F
  ;.byte $38

  .byte $0F, $38

  ;.byte $FD, $1F
  ;.byte $38, $2F, $31

  .byte $1F, $38
  .byte $1F, $2F
  .byte $1F, $31

  ;.byte $FD, $0F
  ;.byte $33, $34

  .byte $0F, $33
  .byte $0F, $34

  ;.byte $FD, $7F
  ;.byte $36, $36

  .byte $7F, $36
  .byte $7F, $36
  .byte $FE

ptn1D =*
  ;.byte $FA, $0B
  ;.byte $FD, $01
  ;.byte $1C, $1C, $1C, $1C

  .byte $81, $0B, $1C
  .byte $01,      $1C
  .byte $01,      $1C
  .byte $01,      $1C

  ;.byte $1C, $1C, $1C, $1C

  .byte $01,      $1C
  .byte $01,      $1C
  .byte $01,      $1C
  .byte $01,      $1C

  ;.byte $1C, $1C, $1C, $1C

  .byte $01,      $1C
  .byte $01,      $1C
  .byte $01,      $1C
  .byte $01,      $1C

  ;.byte $1C, $1C, $1C, $1C

  .byte $01,      $1C
  .byte $01,      $1C
  .byte $01,      $1C
  .byte $01,      $1C

  ;.byte $1C, $1C, $1C, $1C

  .byte $01,      $1C
  .byte $01,      $1C
  .byte $01,      $1C
  .byte $01,      $1C

  ;.byte $1C, $1C, $1C, $1C

  .byte $01,      $1C
  .byte $01,      $1C
  .byte $01,      $1C
  .byte $01,      $1C

  ;.byte $1C, $1C, $1C, $1C

  .byte $01,      $1C
  .byte $01,      $1C
  .byte $01,      $1C
  .byte $01,      $1C

  ;.byte $1C, $1C, $1C, $1C

  .byte $01,      $1C
  .byte $01,      $1C
  .byte $01,      $1C
  .byte $01,      $1C
  .byte $FE

ptn1E =*
  ;.byte $FA, $0B
  ;.byte $FD, $01
  ;.byte $1E, $1E, $1E, $1E

  .byte $81, $0B, $1E
  .byte $01,      $1E
  .byte $01,      $1E
  .byte $01,      $1E

  ;.byte $1E, $1E, $1E, $1E

  .byte $01,      $1E
  .byte $01,      $1E
  .byte $01,      $1E
  .byte $01,      $1E

  ;.byte $1E, $1E, $1E, $1E

  .byte $01,      $1E
  .byte $01,      $1E
  .byte $01,      $1E
  .byte $01,      $1E

  ;.byte $1E, $1E, $1E, $1E

  .byte $01,      $1E
  .byte $01,      $1E
  .byte $01,      $1E
  .byte $01,      $1E

  ;.byte $1E, $1E, $1E, $1E

  .byte $01,      $1E
  .byte $01,      $1E
  .byte $01,      $1E
  .byte $01,      $1E

  ;.byte $1E, $1E, $1E, $1E

  .byte $01,      $1E
  .byte $01,      $1E
  .byte $01,      $1E
  .byte $01,      $1E

  ;.byte $1E, $1E, $1E, $1E

  .byte $01,      $1E
  .byte $01,      $1E
  .byte $01,      $1E
  .byte $01,      $1E

  ;.byte $1E, $1E, $1E, $1E

  .byte $01,      $1E
  .byte $01,      $1E
  .byte $01,      $1E
  .byte $01,      $1E
  .byte $FE

ptn1F =*
  ;.byte $FA, $09
  ;.byte $FD, $3F
  ;.byte $23, $1B, $1C, $1E

  .byte $BF, $09, $23
  .byte $3F,      $1B
  .byte $3F,      $1C
  .byte $3F,      $1E
  .byte $FE

ptn20 =*
  ;.byte $FA, $01
  ;.byte $FD, $7F
  ;.byte $17, $17

  .byte $FF, $01, $17
  .byte $7F,      $17
  .byte $FE

  ; not used?
  ;.byte $21, $26
  ;.byte $FD, $11
  ;.byte $28
  ;.byte $FF

ptn21 =*
  ;.byte $FA, $15
  ;.byte $FD, $01
  ;.byte $1F, $1F

  .byte $81, $15, $1F
  .byte $01,      $1F

  ;.byte $FD, $03
  ;.byte $1F

  .byte $03, $1F

  ;.byte $FA, $0F
  ;.byte $FD, $01
  ;.byte $2E, $27

  .byte $81, $0F, $2E
  .byte $01,      $27

  ;.byte $FA, $15
  ;.byte $1F

  .byte $81, $15, $1F

  ;.byte $FD, $03
  ;.byte $1F

  .byte $03, $1F

  ;.byte $FD, $01
  ;.byte $1F

  .byte $01, $1F

  ;.byte $FD, $03
  ;.byte $1F

  .byte $03, $1F

  ;.byte $FD, $01
  ;.byte $FA, $0F
  ;.byte $2F

  .byte $81, $0F, $2F

  ;.byte $FA, $15
  ;.byte $1A, $1D, $1F

  .byte $81, $15, $1A
  .byte $01,      $1D
  .byte $01,      $1F
  .byte $FE

ptn22 =*
  ;.byte $FA, $09
  ;.byte $FD, $01
  ;.byte $13, $13

  .byte $81, $09, $13
  .byte $01,      $13

  ;.byte $FD, $03
  ;.byte $13

  .byte $03, $13

  ;.byte $FD, $01
  ;.byte $FA, $00
  ;.byte $2E, $27

  .byte $81, $17, $2E
  .byte $01,      $27

  ;.byte $FA, $09
  ;.byte $13

  .byte $81, $09, $13

  ;.byte $FD, $03
  ;.byte $13

  .byte $03, $13

  ;.byte $FD, $01
  ;.byte $13

  .byte $01, $13

  ;.byte $FD, $03
  ;.byte $13

  .byte $03, $13

  ;.byte $FD, $01
  ;.byte $13, $10, $11, $13

  .byte $01, $13
  .byte $01, $10
  .byte $01, $11
  .byte $01, $13
  .byte $FE

ptn23 =*
  ;.byte $FA, $09
  ;.byte $FD, $01
  ;.byte $17, $17

  .byte $81, $09, $17
  .byte $01,      $17

  ;.byte $FD, $03
  ;.byte $17

  .byte $03, $17

  ;.byte $FD, $01
  ;.byte $FA, $00
  ;.byte $2E, $27

  .byte $81, $17, $2E

  .byte $01,      $27

  ;.byte $FA, $09
  ;.byte $17

  .byte $81, $09, $17

  ;.byte $FD, $03
  ;.byte $17

  .byte $03, $17

  ;.byte $FD, $01
  ;.byte $17

  .byte $01, $17

  ;.byte $FD, $03
  ;.byte $17

  .byte $03, $17

  ;.byte $FD, $01
  ;.byte $17, $12, $15, $17

  .byte $01, $17
  .byte $01, $12
  .byte $01, $15
  .byte $01, $17
  .byte $FE

ptn24 =*
  ;.byte $FA, $15
  ;.byte $FD, $01
  ;.byte $23, $23

  .byte $81, $15, $23
  .byte $01,      $23

  ;.byte $FD, $03
  ;.byte $23

  .byte $03, $23

  ;.byte $FA, $0F
  ;.byte $FD, $01
  ;.byte $2E, $27

  .byte $81, $0F, $2E
  .byte $01,      $27

  ;.byte $FA, $15
  ;.byte $23

  .byte $81, $15, $23

  ;.byte $FD, $03
  ;.byte $23

  .byte $03, $23

  ;.byte $FD, $01
  ;.byte $23

  .byte $01, $23

  ;.byte $FD, $03
  ;.byte $23

  .byte $03, $23

  ;.byte $FD, $01
  ;.byte $FA, $0F
  ;.byte $2F

  .byte $81, $0F, $2F

  ;.byte $FA, $15
  ;.byte $1E, $21, $23

  .byte $81, $15, $1E
  .byte $01,      $21
  .byte $01,      $23
  .byte $FE

ptn25 =*
  ;.byte $FA, $0A
  ;.byte $FD, $39
  ;.byte $47

  .byte $B9, $0A, $47

  ;.byte $FD, $01
  ;.byte $46, $45, $44

  .byte $01, $46
  .byte $01, $45
  .byte $01, $44

  ;.byte $FD, $39
  ;.byte $43

  .byte $39, $43

  ;.byte $FD, $01
  ;.byte $44, $45, $46

  .byte $01, $44
  .byte $01, $45
  .byte $01, $46
  .byte $FE

ptn26 =*
  ;.byte $FA, $12
  ;.byte $FD, $3F
  ;.byte $3B, $43, $42, $3E

  .byte $BF, $12, $3B
  .byte $3F,      $43
  .byte $3F,      $42
  .byte $3F,      $3E

  ;.byte $3B, $37, $36, $2F

  .byte $3F,      $3B
  .byte $3F,      $37
  .byte $3F,      $36
  .byte $3F,      $2F
  .byte $FE

ptn27 =*
  ;.byte $FA, $0C
  ;.byte $FD, $01
  ;.byte $31, $3D, $49, $3D

  .byte $81, $0C, $31
  .byte $01,      $3D
  .byte $01,      $49
  .byte $01,      $3D

  ;.byte $31, $3D, $49, $3D

  .byte $01,      $31
  .byte $01,      $3D
  .byte $01,      $49
  .byte $01,      $3D
  .byte $FE

ptn28 =*
  ;.byte $FA, $01
  ;.byte $FD, $7F
  ;.byte $17, $00, $00, $00

  .byte $82               ; made gate=0
  .byte $FF, $01, $17
  .byte $82                ; made gate=0
 ; .byte $FF, $04, $00

  .byte $FF, $18, $17
  .byte $FF, $04, $00
  .byte $7F,      $00
  .byte $FE

ptn29 =*
  ;.byte $FA, $01
  ;.byte $FD, $7F
  ;.byte $23, $00, $00, $00

  .byte $82                ; made gate=0
  .byte $FF, $01, $23
  .byte $82                ; made gate=0
  .byte $FF, $04, $00
  .byte $7F,      $00
  .byte $7F,      $00
  .byte $FE

ptn2A =*                   ; a patch for having some level to the sound
   .byte $82               ; made gate=0
   .byte $81, $04, $00
   .byte $FD, $16, $17
   .byte $FF, $04, $00
   .byte $FE

ptn2B =*                   ; a patch for having some level to the sound
   .byte $84               ; made gate=0 for a cycle
   .byte $FF, $16, $23
   .byte $FE

ptn2C =*

ptn2D =*                   ; like 25h with release
  ;.byte $FA, $0A
  ;.byte $FD, $39
  ;.byte $47

  .byte $B9, $0A, $47

  ;.byte $FD, $01
  ;.byte $46, $45, $44

  .byte $01, $46
  .byte $01, $45
  .byte $01, $44

  ;.byte $FD, $39
  ;.byte $43

  .byte $39, $43

  ;.byte $FD, $01
  ;.byte $44, $45, $46

  .byte $01, $44
  .byte $01, $45
  .byte $84               ; gate = 0 before end
  .byte $01, $46
  .byte $FE

ptn2E =*                  ; like 06 but with gate=0 before end
   ;.byte $FA, $06
   ;.byte $FD, $01
   ;.byte $42, $3B, $3B, $42

   .byte $81, $06, $42
   .byte $01,      $3B
   .byte $01,      $3B
   .byte $01,      $42

   ;.byte $3B, $3B, $43, $3B

   .byte $01,      $3B
   .byte $01,      $3B
   .byte $01,      $43
   .byte $01,      $3B

   ;.byte $42, $3B, $3B, $42

   .byte $01,      $42
   .byte $01,      $3B
   .byte $01,      $3B
   .byte $01,      $42

   ;.byte $3B, $3B, $43, $3B

   .byte $01,      $3B
   .byte $01,      $3B
   .byte $01,      $43
   .byte $01,      $3B

   ;.byte $42, $3B, $3B, $42

   .byte $01,      $42
   .byte $01,      $3B
   .byte $01,      $3B
   .byte $01,      $42

   ;.byte $3B, $3B, $43, $3B

   .byte $01,      $3B
   .byte $01,      $3B
   .byte $01,      $43
   .byte $01,      $3B

   ;.byte $42, $3B, $3B, $42

   .byte $01,      $42
   .byte $01,      $3B
   .byte $01,      $3B
   .byte $01,      $42

   ;.byte $3B, $3B, $43, $3B

   .byte $01,      $3B
   .byte $01,      $3B
   .byte $01,      $43
   .byte $84                ; gate = 0 before end
   .byte $01,      $3B
   .byte $FE

;====================================
;instruments
;====================================

instr =*
 .byte $00,$00,$81,$0a,$00,$00,$00,$04 ; 00h

 .byte $00,$09,$41,$fe,$8f,$02,$58,$00 ; 01: for the long sound

 .byte $00,$00,$81,$dd,$61,$02,$02,$00 ; ?
 ;.byte $00,$90,$41,$dd,$65,$01,$40,$00 ; ?

 .byte $00,$00,$81,$09,$09,$00,$00,$05 ; not used
 .byte $00,$00,$00,$00,$00,$00,$00,$00 ; mute
 .byte $00,$01,$41,$3f,$c0,$02,$00,$00 ; not used

 .byte $00,$08,$41,$04,$40,$02,$00,$00 ; 06h

 .byte $00,$00,$81,$19,$51,$01,$00,$05 ;ok??
 .byte $00,$09,$41,$09,$76,$02,$5f,$00 ;il portamento no ok

 .byte $00,$00,$21,$0a,$fa,$00,$00,$00 ;ok

 .byte $00,$08,$41,$00,$60,$00,$41,$04  ; ah ok?

 ;.byte $00,$08,$41,$04,$40,$02,$00,$00 ;okk (old ma pu tornare utile)
 .byte $00,$07,$41,$00,$60,$01,$F0,$03


 .byte $00,$09,$81,$03,$60,$01,$02,$01  ; drum
 .byte $00,$08,$41,$90,$f0,$01,$28,$00  ; dh
 .byte $00,$04,$41,$ee,$60,$00,$04,$00 ; 0Eh (S=4?)
 .byte $09,$08,$41,$09,$00,$02,$a8,$01  ;fh drum?
 .byte $00,$00,$21,$00,$60,$02,$02,$00  ; 10h ok?, ma bassa di vol
 .byte $00,$00,$00,$00,$00,$00,$00,$00  ; 11h not used
 .byte $00,$00,$11,$0a,$fa,$00,$00,$00  ; 12h cos  continuo ma alto
 .byte $00,$08,$41,$37,$40,$02,$00,$00 ; 13h
 .byte $00,$00,$00,$00,$00,$00,$00,$00  ; 14h not used
 .byte $0f,$01,$41,$0c,$00,$02,$00,$05  ;15hdrum?

 .byte $00,$09,$41,$ff,$5f,$02,$58,$00 ;16h: like 01 but I need less amplitude
 .byte $00,$00,$81,$0a,$00,$00,$00,$07 ; 17h like 00h
 .byte $00,$09,$41,$33,$50,$02,$58,$00
.end
